QGIS Application - Bug report #19764
Features in memory layers are not accessible by pyQGIS scripts
2018-09-04 08:11 AM - Michael Kuerbs

Status: Closed

Priority: Normal

Assignee: Nyall Dawson

Category: PyQGIS Console

Affected QGIS version:3.2.2 Regression?: No
Operating System: Win 7 or Win 10 Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 27589
Description

Features in memory layers are not accessible.

QgsFeature.attributes() is a emty list []
QgsFeature.geometry() is a emty geometry

If | save the memory layer in a shp or something else, it works very well.

History

#1 - 2018-09-04 10:54 AM - Giovanni Manghi

- Priority changed from High to Normal

- Pull Request or Patch supplied changed from Yes to No
#2 - 2018-09-04 11:25 AM - Nyall Dawson

- Status changed from Open to Feedback

More information is required here.

#3 - 2018-09-04 11:46 AM - Michael Kuerbs

- Assignee set to Nyall Dawson

| create a memory layer with one feature included attributes.

Now | would access this Feature directly with

feat = layer.getFeature(0)
print(feat.attributes(), feat.geometry().asWkt()) =>[] ™

if i work with real storage Layers the first feature is getting with layer.getFeature(0)

if it's a memory layer, the first feature is getting with layer.getFeature(1)

if i get features by iterating, it works very well

why is the index using different in case of menory layers?
#4 - 2018-09-04 11:49 AM - Nyall Dawson

Feature IDs aren't consistent across providers - they are stable within a particular layer, but won't be transferred if that layer is saved to a different format

or provider.

#5 - 2018-09-04 12:02 PM - Jiirgen Fischer

feat = layer.getFeature(0)

getFeature takes a feature id and not an index. And the feature id is provider/data source specific. You shouldn't make assumptions about it other than

you can address a feature with the id you got from the layer - as it might not even be safe to assume that features from the same datasource, but on
different layers have the same id).

#6 - 2018-09-04 12:45 PM - Michael Kuerbs

I would like just the first feature a layer.

#7 - 2018-09-04 12:50 PM - Nyall Dawson
- Status changed from Feedback to Closed

In that case:

feature = next(layer.getFeatures())

(or better)

feature = next(layer.getFeatures(QgsFeatureRequest().setLimit(1))

2025-04-27 22


https://qgis.org/api/classQgsVectorLayer.html#aa4886de4c49b0656cc0f47025fe2631b

